unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, jpeg, ExtCtrls, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N11: TMenuItem;
    N21: TMenuItem;
    N5: TMenuItem;
    N12: TMenuItem;
    N22: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Timer1: TTimer;
    Timer2: TTimer;
    Image2: TImage;
    procedure N11Click(Sender: TObject);
    procedure RadClick(Sender: TObject);
    procedure RadClick2(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure N21Click(Sender: TObject);
    procedure N12Click(Sender: TObject);
    procedure N22Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure N7Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
  private
    procedure Click;
    procedure Click2;
    procedure ReadFile(S: string);
    procedure Save(St, Sb: string);
    { Private declarations }
  public
    { Public declarations }
  end;

var Kol, Galka, Ball, Vop: Integer;
    i, j, k, n, Ps: Integer;
    Ok, First: Boolean;
    F: TextFile;
    Nazt, S: string;
    RadBut: array [1..10] of TRadioButton;
  Form1: TForm1;

implementation

uses Unit2, Unit3, Unit4, Unit5;

{$R *.dfm}

type
  TTest = record
    Question: string;
    KolV: Integer;
    KolO: Integer;
    Vopros: array [1..10] of
      record
        Text: string;
        Otvet: string;
      end;
    VarOtvet: array [1..10] of string;
  end;
  ObT = record
       Title: string;
       Otvet: string;
       Varit: array [1..3] of string;
      end;

var Test: array [1..10] of TTest;
    TsT: array [1..25] of ObT; 

procedure TForm1.Save(St, Sb: string);
var s1, s2: string;
    Mem: TMemo;
begin
  AssignFile(F, '\ .txt');
  Append(F);
  s1 := Form3.Edit1.Text;
  s2 := Form3.Edit2.Text;
  Writeln(F, ': ', s1, '     ', s2);
  Writeln(F, ' : ', St);
  Writeln(F, '  : ', Sb);
  Writeln(F, ' : ', DateToStr(Now));  
  Writeln(F, '');
  CloseFile(F);
end;

procedure TForm1.Click;
begin
  Image2.Visible := False;
  if j = Test[i].KolV then
    begin
      if Galka = Test[i].KolV then
        begin
          if (First) and (i > 2) and (i < 18) then
            begin
              if Galka = 20 then Inc(Ball);
            end
          else
            begin
              Inc(Ball);
              Galka := 0;
            end;
        end;
      j := 0;
      Inc(i);
    end;
  if i > Vop then
    begin
      Label1.Visible := False;
      Label2.Visible := False;
      for k:= 1 to Test[i].KolO do
        RadBut[k].Visible := False;
      case Ball of
        0..2: S := '';
           3: S := '';
           4: S := '';
         5,6: S := '';
      end;
      Save(Nazt, S);
      MessageDlg(' : ' + S, mtInformation, [mbOk], 0);
      Exit;      
    end;
  Inc(j);
  Label1.Caption := Test[i].Question;
  Label1.Width := 900;
  Label1.Left := 50 + Round((Form1.ClientWidth - Label1.Width)/2);
  Label2.Width := 900;
  Label2.Caption := Test[i].Vopros[j].Text;
  Label2.Left := Round((Form1.ClientWidth - Label2.Width)/2);
  for k:= 1 to Test[i].KolO do
        begin
          RadBut[k] := TRadioButton.Create(Self);
          RadBut[k].Parent := Self;
          RadBut[k].Font.Size := 16;
          RadBut[k].Color := clYellow;
          RadBut[k].Font.Name := 'Times New Roman';
          RadBut[k].Font.Style := [fsBold, fsItalic];
          RadBut[k].Top := 270 + k*50;
          if i = 6 then RadBut[k].Left := 50 else RadBut[k].Left := 300;
          RadBut[k].Width := 1000;
          RadBut[k].Height := 35;
          RadBut[k].Caption := Test[i].VarOtvet[k];
          RadBut[k].OnClick := RadClick;
          Self.InsertControl(RadBut[k]);
        end;
  if (not First) and (i = 4) then
    Image2.Visible := True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Tag := Timer1.Tag + 1;
  if Timer1.Tag > 1 then
    begin
      Timer1.Enabled := False;
      for k:= 1 to Test[i].KolO do
        RadBut[k].Visible := False;
      Click;
    end;
end;

procedure TForm1.RadClick(Sender: TObject);
begin
  Timer1.Tag := 0;
  Timer1.Enabled := True;
  for k:= 1 to Test[i].KolO do
    begin
      if RadBut[k].Checked then
        if Test[i].Vopros[j].Otvet = RadBut[k].Caption
          then Inc(Galka);
    end;
end;

procedure TForm1.ReadFile(S: string);
begin
  AssignFile(F, S);
  Reset(F);
  i := 0;
  Readln(F, Vop);
  while not Eof(F) do
    begin
      Inc(i);
      Test[i].Question := '';
      repeat
        Readln(F, S);
        if S <> '-' then
          Test[i].Question := Test[i].Question + S;
      until S = '-';
      Readln(F, n);
      Test[i].KolV := n;
      for j:= 1 to n do
        begin
          Readln(F, S);
          Ok := False;
          for k:= 1 to Length(S) do
            begin
              if S[k] = '.' then
                begin
                  Ps := k;
                  Ok := True;
                  Kol := 0;
                end;
              if Ok then Inc(Kol);
            end;
          Test[i].Vopros[j].Text := Copy(S, 1, Ps - 1);
          Test[i].Vopros[j].Otvet := Copy(S, Ps + 1, Kol);
        end;
      Readln(F, n);
      Test[i].KolO := n;
      for j:= 1 to n do
        begin
          Readln(F, S);
          Test[i].VarOtvet[j] := S;
        end;
      Readln(F);
    end;
  CloseFile(F);
  Label1.Visible := True;
  Label2.Visible := True;
  i := 1;
  j := 0;
  Ball := 0;
  Galka := 0;
  Click;
end;

procedure TForm1.RadClick2(Sender: TObject);
begin
  Timer2.Tag := 0;
  Timer2.Enabled := True;
  for k:= 1 to 3 do
    begin
      if RadBut[k].Checked then
        if RadBut[k].Caption = TsT[i].Otvet
          then Inc(Ball);
    end;
end;

procedure TForm1.Click2;
begin
  if i = 25 then
    begin
      Label1.Visible := False;
      for k:= 1 to 3 do
        RadBut[k].Visible := False;
      case Ball of
         0..10: S := '';
        11..16: S := '';
        17..22: S := '';
        23..25: S := '';
      end;
      Save(Nazt, S);
      MessageDlg(' : ' + S, mtWarning, [mbOk], 0);
      Exit;
    end;
  Inc(i);
  Label1.Caption := TsT[i].Title;
  Label1.Width := 900;
  for k:= 1 to 3 do
        begin
          RadBut[k] := TRadioButton.Create(Self);
          RadBut[k].Parent := Self;
          RadBut[k].Font.Size := 16;
          RadBut[k].Color := clYellow;
          RadBut[k].Font.Name := 'Times New Roman';
          RadBut[k].Font.Style := [fsBold, fsItalic];
          RadBut[k].Top := 250 + k*50;
          RadBut[k].Left := 250;
          RadBut[k].Width := 500;
          RadBut[k].Height := 35;
          RadBut[k].Caption := TsT[i].Varit[k];
          RadBut[k].OnClick := RadClick2;
          Self.InsertControl(RadBut[k]);
        end;
end;

procedure TForm1.N3Click(Sender: TObject);
begin
  AssignFile(F, '\ .txt');
  Reset(F);
  i := 0;
  repeat
      Inc(i);
      Readln(F, S);
      TsT[i].Title := S;
      Readln(F, S);
      TsT[i].Otvet := S;
      for k:= 1 to 3 do
        begin
          Readln(F, S);
          TsT[i].Varit[k] := S;
        end;
      Readln(F);
  until i = 25;
  CloseFile(F);
  i := 0;
  Ball := 0;
  Label1.Visible := True;
  Nazt := ' ';
  Click2;
end;


procedure TForm1.Timer2Timer(Sender: TObject);
begin
  Timer2.Tag := Timer2.Tag + 1;
  if Timer2.Tag > 1 then
    begin
      Timer2.Enabled := False;
      for k:= 1 to 3 do
        RadBut[k].Visible := False;
      Click2;
    end;
end;

procedure TForm1.N11Click(Sender: TObject);
begin
  Nazt := '_1';
  ReadFile('\_1.txt');
  First := True;
end;

procedure TForm1.N21Click(Sender: TObject);
begin
  Nazt := '_2';
  ReadFile('\_2.txt');
  First := True;
end;

procedure TForm1.N12Click(Sender: TObject);
begin
  Nazt := '_1';
  ReadFile('\_1.txt');
  First := False;
end;

procedure TForm1.N22Click(Sender: TObject);
begin
  Nazt := '_2';
  ReadFile('\_1.txt');
  First := False;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Application.Terminate;
end;

procedure TForm1.N7Click(Sender: TObject);
begin
 form4.show;
end;

procedure TForm1.N1Click(Sender: TObject);
begin
 form5.show;
end;

end.
